#include <windows.h>

#define PDF2IMAGE_MODULE_NAME		("pdf2image.dll")

typedef int (__stdcall * pfnPDFToImageConverter)(
	const char *szPDFFileName,
	const char *szOutputName,
	const char *szUserPassword,
	const char *szOwnPassword,
	int xresolution,
	int yresolution,
	int bitcount,
	int compression,
	int quality,
	BOOL grayscale,
	BOOL multipage,
	int firstPage,
	int lastPage);

typedef void (__stdcall * pfnPDFToImageSetFileNameSuffix)(const char *ptrFileNameSuffix);

#define	    COMPRESSION_NONE        1			// dump mode
#define	    COMPRESSION_CCITTRLE    2			// CCITT modified Huffman RLE
#define	    COMPRESSION_CCITTFAX3   3			// CCITT Group 3 fax encoding
#define	    COMPRESSION_CCITTFAX4   4			// CCITT Group 4 fax encoding
#define	    COMPRESSION_LZW         5			// Lempel-Ziv  & Welch
#define	    COMPRESSION_JPEG        7			// %JPEG DCT compression
#define	    COMPRESSION_PACKBITS    32773		// Macintosh RLE
#define		COMPRESSION_CLASSF204X98_G3     88888886  //Convert PDF to 204x98 DPI ClassF G3 compatible TIFF file 
#define		COMPRESSION_CLASSF204X196_G3	88888887  //Convert PDF to 204x196 DPI ClassF G3 compatible TIFF file
#define		COMPRESSION_CLASSF204X98_G4     88888888  //Convert PDF to 204x98 DPI ClassF G4 compatible TIFF file
#define		COMPRESSION_CLASSF204X196_G4	88888889  //Convert PDF to 204x196 DPI ClassF G4 compatible TIFF file

void TestPdf(const char* pdf_filename, const char* out_filename)
{
	const HMODULE dll_handle = LoadLibrary(PDF2IMAGE_MODULE_NAME);
	if(dll_handle)
	{
		pfnPDFToImageConverter PDFToImageConverter = (pfnPDFToImageConverter)
			GetProcAddress(dll_handle, "PDFToImageConverter");
		pfnPDFToImageSetFileNameSuffix PDFToImageSetFileNameSuffix = (pfnPDFToImageSetFileNameSuffix)
			GetProcAddress(dll_handle, "PDFToImageSetFileNameSuffix");
		if(PDFToImageConverter && PDFToImageSetFileNameSuffix)
		{
			PDFToImageSetFileNameSuffix("_%03u");
			PDFToImageConverter(pdf_filename, out_filename, "", "", 200, 200, 8, COMPRESSION_NONE, 100, FALSE, FALSE, 1, 1); // 8-bit, grayscale = FALSE, yet output is grayscale!
		}
		FreeLibrary(dll_handle);
	}
}

int main(int argc, CHAR* argv[])
{
	TestPdf("D:\\downloads\\8BitGrayscale\\input.pdf", "D:\\downloads\\8BitGrayscale\\input.bmp");
	return 0;
}

